> ## Documentation Index
> Fetch the complete documentation index at: https://docs.domino.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Create a Data Source

> Create a Data Source



## OpenAPI

````yaml /api-specs/6.3/public-api.json post /api/datasource/v1/datasources
openapi: 3.0.3
info:
  title: Domino Public API
  description: Reference for Domino's public REST API endpoints.
  version: 6.3.1
  x-catalog-key: nucleus
servers:
  - url: https://mycluster.domino.tech
    description: >-
      Replace 'mycluster.domino.tech' with your Domino cluster hostname. For
      Domino Cloud customers, that is `your-subdomain`.domino.tech (e.g.,
      acme.domino.tech). For self-hosted deployments, it is the hostname you
      reach the Domino UI at.
security: []
tags:
  - name: Projects
  - name: Project templates
  - name: Workspaces
  - name: Jobs
  - name: HPC Jobs
  - name: Environments
  - name: Hardware Tiers
  - name: Datasets
  - name: Data Sources
  - name: AI Gateway
  - name: GenAI
  - name: AI Systems
  - name: Apps
  - name: App versions
  - name: App instances
  - name: Model APIs
  - name: Registered models
  - name: Model deployment
  - name: Extensions
  - name: Cost and billing
  - name: Users and organizations
  - name: Service accounts
  - name: Personal Access Tokens
  - name: Personal Access Tokens (admin)
  - name: Audit Trail
  - name: Custom metrics
  - name: PPM
  - name: Model Monitoring models
  - name: Model Monitoring drift and quality
  - name: Model Monitoring settings
  - name: Model Monitoring authentication
  - name: Governance bundles
  - name: Governance policies
  - name: Governance evidence and results
  - name: Governance operations
  - name: NetApp Volumes
  - name: NetApp Volumes snapshots
  - name: NetApp Volumes filesystems
  - name: NetApp Volumes transfers
  - name: Tags
  - name: Properties
externalDocs:
  description: OpenAPI
  url: https://swagger.io/resources/open-api/
paths:
  /api/datasource/v1/datasources:
    post:
      tags:
        - Data Sources
      summary: Create a Data Source
      description: Create a Data Source
      operationId: createDataSource
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/NewDataSourceV1'
        description: Data Source to create
        required: true
      responses:
        '200':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/DataSourceEnvelopeV1'
          description: Success
        '400':
          $ref: '#/components/responses/400'
        '401':
          $ref: '#/components/responses/401'
        '403':
          $ref: '#/components/responses/403'
        '404':
          $ref: '#/components/responses/404'
        '500':
          $ref: '#/components/responses/500'
      security:
        - DominoApiKey: []
        - BearerAuthentication: []
components:
  schemas:
    NewDataSourceV1:
      properties:
        authType:
          $ref: '#/components/schemas/DataSourceAuthTypeV1'
        config:
          $ref: '#/components/schemas/DataSourceConfigV1'
        credentialType:
          $ref: '#/components/schemas/DataSourceCredentialTypeV1'
        credentials:
          $ref: '#/components/schemas/DataSourceCredentialsV1'
        dataSourceType:
          $ref: '#/components/schemas/DataSourceTypeV1'
        description:
          description: Description of the Data Source
          example: My Data Source
          type: string
        name:
          description: User given name of the Data Source
          example: data-source-name
          type: string
        permissions:
          $ref: '#/components/schemas/DataSourcePermissionsV1'
      required:
        - name
        - dataSourceType
        - authType
        - credentialType
        - credentials
        - config
        - permissions
      type: object
    DataSourceEnvelopeV1:
      properties:
        authType:
          $ref: '#/components/schemas/DataSourceAuthTypeV1'
        config:
          $ref: '#/components/schemas/DataSourceConfigV1'
        credentialType:
          $ref: '#/components/schemas/DataSourceCredentialTypeV1'
        dataSourceType:
          $ref: '#/components/schemas/DataSourceTypeV1'
        description:
          description: Description of the Data Source
          example: My Data Source
          type: string
        displayName:
          description: Data Source display name
          example: Azure Data Lake Store
          type: string
        id:
          description: ID of the Data Source
          example: 62604702b7e5d347dbe7a909
          type: string
        lastUpdated:
          description: ISO 8601 formatted time of when the Data Source was last updated
          example: '2022-04-23T18:25:43.511Z'
          format: date-time
          type: string
        name:
          description: User given name of the Data Source
          example: data-source-name
          type: string
        ownerId:
          description: ID of the Data Source owner
          example: 62604702b7e5d347dbe7a909
          type: string
        ownerUsername:
          description: Username of the owner of the Data Source
          example: owner-username
          type: string
        permissions:
          $ref: '#/components/schemas/DataSourcePermissionsV1'
      required:
        - id
        - name
        - ownerId
        - ownerUsername
        - dataSourceType
        - authType
        - credentialType
        - config
        - permissions
        - lastUpdated
        - displayName
      type: object
    DataSourceAuthTypeV1:
      description: The type of Data Source authentication
      example: AzureBasic
      type: string
    DataSourceConfigV1:
      additionalProperties:
        type: string
      description: A map of configuration name -> value
      example:
        host: example-host.com
      type: object
    DataSourceCredentialTypeV1:
      description: Whether the credentials is individual to a user or shared
      enum:
        - Individual
        - Shared
      type: string
    DataSourceCredentialsV1:
      properties:
        secretCredentials:
          additionalProperties:
            type: string
          description: Map of secret credentials fields -> value
          type: object
        visibleCredentials:
          additionalProperties:
            type: string
          description: Map of non-secret credentials fields -> value
          type: object
      required:
        - visibleCredentials
        - secretCredentials
      type: object
    DataSourceTypeV1:
      description: The configuration type of the Data Source
      example: ADLSConfig
      type: string
    DataSourcePermissionsV1:
      properties:
        isEveryone:
          description: If the Data Source is accessible by everyone
          type: boolean
        userAndOrganizationIds:
          description: User and Organization IDs that can access this Data Source
          items:
            type: string
          type: array
      required:
        - isEveryone
        - userAndOrganizationIds
      type: object
    ErrorV1:
      properties:
        code:
          description: Machine-readable error code.
          example: NOT_FOUND
          type: string
        message:
          description: Human-readable description of the error.
          example: The requested HPC Job could not be found.
          type: string
      required:
        - message
      type: object
  responses:
    '400':
      content:
        application/json:
          schema:
            properties:
              error:
                type: string
            type: object
      description: Bad Request
    '401':
      content:
        application/json:
          example:
            code: UNAUTHORIZED
            message: Authentication is required to access this resource.
          schema:
            $ref: '#/components/schemas/ErrorV1'
      description: Unauthorized - authentication is required or has failed.
    '403':
      content:
        application/json:
          example:
            code: FORBIDDEN
            message: You do not have permission to perform this action.
          schema:
            $ref: '#/components/schemas/ErrorV1'
      description: Forbidden - the caller lacks permission to perform this action.
    '404':
      content:
        application/json:
          schema:
            properties:
              error:
                type: string
            type: object
      description: Not Found
    '500':
      content:
        application/json:
          schema:
            properties:
              error:
                type: string
            type: object
      description: Internal Server Error
  securitySchemes:
    DominoApiKey:
      type: apiKey
      in: header
      name: X-Domino-Api-Key
    BearerAuthentication:
      type: apiKey
      name: Authorization
      in: header

````

## Related topics

- [Manage Data Sources](/6.3/admin/data-administration/external-data/index.md)
- [Use Data Sources](/6.3/platform-capabilities/core-concepts/data/data-source-connectors/use-data-sources.md)
- [Domino Data Sources](/6.3/platform-capabilities/core-concepts/data/data-source-connectors/index.md)
- [Data Source use cases](/6.3/reference/api/data_api/datasource_usecases/index.md)
